/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
CREATE PROCEDURE InsertConfigurationKeysFromXML(
    @sXML NTEXT
)
AS
begin transaction
    DECLARE @iDoc INT
    EXEC sp_xml_preparedocument @iDoc OUTPUT, @sXML
                       
INSERT INTO dbo.ConfigurationKeys (DisplayName, SettingsClassFieldName,
KeyValue,DataType,Description,ReadOnly,
ValidValues,LastUpdate,KeyLevel,ConfigurationServiceName,DisplayOrder, GroupName, HostNameIdentifier)
 
 SELECT DisplayName, SettingsClassFieldName,
KeyValue,DataType,Description,ReadOnly,
ValidValues,LastUpdate,KeyLevel,ConfigurationServiceName,DisplayOrder, GroupName, HostNameIdentifier
    FROM OPENXML(@iDoc,'/ConfigurationKeys/dbo.ConfigurationKeys',2)
    WITH (	DisplayName varchar(200) 'DisplayName', 
			SettingsClassFieldName varchar(200) 'SettingsClassFieldName', 
			KeyValue varchar(200) 'KeyValue',
			DataType varchar(100) 'DataType',
			Description varchar(600) 'Description',
			ReadOnly varchar(10) 'ReadOnly',
			ValidValues varchar(250) 'ValidValues',
			LastUpdate DateTime 'LastUpdate',
			KeyLevel int 'KeyLevel',
			ConfigurationServiceName varchar(200) 'ConfigurationServiceName',
			DisplayOrder int 'DisplayOrder',
			GroupName varchar(200) 'GroupName',
			HostNameIdentifier varchar(200) 'HostNameIdentifier');
	commit;
    EXEC sp_xml_removedocument @iDoc;
RETURN


